package de.srsoftware.belegscanner.gui;

import de.srsoftware.belegscanner.Worker;

import javax.swing.*;
import java.awt.*;

import static de.srsoftware.belegscanner.Application.t;
import static java.awt.BorderLayout.NORTH;
import static java.awt.BorderLayout.SOUTH;
import static java.awt.BorderLayout.WEST;

public class ImproveSelector extends JPanel {

    private final JCheckBox brightnessCheckbox,stitchPages;

    public ImproveSelector(Worker worker) {
        super(new BorderLayout());
        add(new JLabel(t("Adjustments")), NORTH);
        brightnessCheckbox = new JCheckBox(t("Improve brightness"));
        add(brightnessCheckbox,WEST);
        stitchPages = new JCheckBox(t("Remove [PAGE] when stitching"));
        add(stitchPages,SOUTH);
        setMaximumSize(new Dimension(600,200));
        brightnessCheckbox.addActionListener(e -> {
            worker.setImproveBrightness(brightnessCheckbox.isSelected());
        });
        stitchPages.addActionListener(e -> {
            worker.setRemovePageOnStitching(stitchPages.isSelected());
        });
        worker.setImproveSelector(this);
    }

    public void setImproveBrightness(boolean newVal) {
        brightnessCheckbox.setSelected(newVal);
    }

    public void setDropPage(boolean newVal) {
        stitchPages.setSelected(newVal);
    }
}
