package de.srsoftware.belegscanner.gui;

import de.srsoftware.belegscanner.Worker;
import org.icepdf.ri.common.ComponentKeyBinding;
import org.icepdf.ri.common.SwingController;
import org.icepdf.ri.common.SwingViewBuilder;
import org.icepdf.ri.common.views.DocumentViewController;

import javax.swing.*;
import java.awt.*;

public class Preview extends JPanel {
    private final SwingController pdfViewer;
    private final JLabel fileName;

    Preview(Worker worker){
        // https://stackoverflow.com/a/48248739/1285585
        super(new BorderLayout());

        pdfViewer = new SwingController();
        SwingViewBuilder factory = new SwingViewBuilder(pdfViewer);

        JPanel viewerComponentPanel = factory.buildViewerPanel();

        ComponentKeyBinding.install(pdfViewer, viewerComponentPanel);
        // add interactive mouse link annotation support via callback
        pdfViewer.getDocumentViewController().setAnnotationCallback(new org.icepdf.ri.common.MyAnnotationCallback(pdfViewer.getDocumentViewController()));

        add(viewerComponentPanel,BorderLayout.CENTER);
        setBorder(BorderFactory.createLineBorder(Color.black));

        add(fileName = new JLabel(),BorderLayout.SOUTH);
        fileName.setHorizontalAlignment(SwingConstants.CENTER);
    }

    public void show(String file) {
        pdfViewer.openDocument(file);
        pdfViewer.setPageFitMode(DocumentViewController.PAGE_FIT_WINDOW_HEIGHT, false);
    }
}
