package de.srsoftware.belegscanner.gui;

import de.srsoftware.belegscanner.Worker;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static de.srsoftware.belegscanner.Application.t;
import static java.awt.BorderLayout.CENTER;
import static java.awt.BorderLayout.NORTH;

public class ResolutionSelector extends JPanel{

   private class ResolutionButton extends JRadioButton{
       int resolution;

       ResolutionButton(ButtonGroup group, JLabel label, int resolution){
            super(resolution+" px");
            this.resolution = resolution;
            buttons.add(this);
            group.add(this);
           addActionListener(ev -> {
               label.setText("aktuelle Auflösung: "+worker.setResolution(resolution)+"px");
           });
           if (resolution==150) setSelected(true);
        }

       public void selectOnMatch(int newVal) {
           setSelected(resolution == newVal);
       }
   }
    private final Worker worker;

    private List<ResolutionButton> buttons = new ArrayList<>();

    public ResolutionSelector(Worker worker) {
        super(new BorderLayout());
        this.worker = worker;

        ButtonGroup group = new ButtonGroup();
        JLabel label = new JLabel(t("current resolution") + ": " + worker.setResolution(150) + "px");
        add(label, NORTH);
        var buttons = new JPanel();
        buttons.setLayout(new BoxLayout(buttons,BoxLayout.X_AXIS));
        buttons.add(new ResolutionButton(group, label, 150));
        buttons.add(new ResolutionButton(group, label, 300));
        buttons.add(new ResolutionButton(group, label, 600));
        buttons.add(Box.createHorizontalGlue());
        add(buttons,CENTER);
        setMaximumSize(new Dimension(600, 200));
        worker.setResolutionSelector(this);
    }




    public void set(int resolution) {
        buttons.forEach(btn -> btn.selectOnMatch(resolution));
    }
}
