package de.srsoftware.belegscanner.gui;

import de.srsoftware.belegscanner.Worker;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static de.srsoftware.belegscanner.Application.t;
import static java.awt.BorderLayout.CENTER;
import static java.awt.BorderLayout.NORTH;

public class RotationSelector extends JPanel {


    private class RotationButton extends JRadioButton{

        private final int angle;

        public RotationButton(ButtonGroup group, int angle) {
            super(angle+"°");
            this.angle = angle;
            if (angle==150) setSelected(true);
            addActionListener(ev -> {
                worker.setRotation(angle);
            });
            group.add(this);
            buttons.add(this);
        }

        public void enableIf(int newVal) {
            setSelected(angle == newVal);
        }
    }

    private List<RotationButton> buttons = new ArrayList<>();
    private final Worker worker;
    private final JRadioButton noRotation;

    public RotationSelector(Worker worker) {
        super(new BorderLayout());
        this.worker = worker.setRotation(0);
        ButtonGroup group = new ButtonGroup();
        var radios = new JPanel();
        radios.setLayout(new BoxLayout(radios,BoxLayout.X_AXIS));
        radios.add(noRotation = new RotationButton(group,  0));
        radios.add(new RotationButton(group,  90));
        radios.add(new RotationButton(group,  180));
        radios.add(new RotationButton(group,  -90));
        noRotation.setSelected(true);
        add(new JLabel(t("Rotation")),NORTH);
        add(radios,CENTER);
        setMaximumSize(new Dimension(600, 200));
        worker.setRotationSelector(this);
    }

    public void set(Integer angle) {
        buttons.forEach(b -> b.enableIf(angle));
    }
}
