package de.srsoftware.belegscanner.gui;

import de.srsoftware.belegscanner.Worker;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static de.srsoftware.belegscanner.Application.t;
import static de.srsoftware.belegscanner.Constants.JPG;
import static de.srsoftware.belegscanner.Constants.OCR;
import static de.srsoftware.belegscanner.Constants.PDF;
import static java.awt.BorderLayout.CENTER;
import static java.awt.BorderLayout.NORTH;
import static javax.swing.BoxLayout.X_AXIS;

public class TypeSelector extends JPanel {

    private class TypeButton extends JRadioButton{

        private final String type;

        public TypeButton(ButtonGroup group, String type) {
            super(t(type));
            this.type = type;
            addActionListener(ev -> worker.setType(type));
            group.add(this);
            buttons.add(this);
        }

        public void enableOn(String type) {
            setSelected(this.type.equals(type));
        }
    }
    private final Worker worker;

    private List<TypeButton> buttons = new ArrayList<>();

    public TypeSelector(Worker worker){
        super(new BorderLayout());
        this.worker = worker;
        ButtonGroup group = new ButtonGroup();
        JLabel label = new JLabel(t("Target type"));
        add(label, NORTH);
        var buttons = new JPanel();
        buttons.setLayout(new BoxLayout(buttons,X_AXIS));
        buttons.add(new TypeButton(group,JPG));
        buttons.add(new TypeButton(group,PDF));
        buttons.add(new TypeButton(group,OCR));
        add(buttons,CENTER);
        setMaximumSize(new Dimension(600,200));
        worker.setTypeSelector(this);
        set(OCR);
    }

    public void set(String type) {
        buttons.forEach(b -> b.enableOn(type));
    }

}
