package de.srsoftware.belegscanner.model;

import de.srsoftware.belegscanner.Constants;
import de.srsoftware.belegscanner.model.api.Page;
import de.srsoftware.belegscanner.model.api.Project;

import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static de.srsoftware.belegscanner.Application.t;

public class ScanProject implements Project {
private static final String PAGE = t(Constants.PAGE);
    private final String pattern;
    private List<Page> pageList = new ArrayList<>();

    public ScanProject(String resolvedPath){
        this.pattern = resolvedPath;
    }
    @Override
    public String pattern() {
        return pattern;
    }

    @Override
    public File nextFile() {
        return new File(pattern.replace("["+PAGE+"]",nextPage()+""));
    }

    @Override
    public List<Page> pages() {
        return pageList;
    }

    @Override
    public int nextPage() {
        return pageList.size()+1;
    }

    @Override
    public void openDir() {
        File dir = new File(pattern).getParentFile();
        if (dir.exists()) try {
            Desktop.getDesktop().open(dir);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public Page lastPage() {
        return pageList.isEmpty() ? null : pageList.get(pageList.size()-1);
    }

    @Override
    public void join() {

    }

    @Override
    public Page addPage(File file) {
        Page newPage = new ScannedPage(file);
        pageList.add(newPage);
        return newPage;
    }

    @Override
    public Project dropLastPage() {
        if (pageList.isEmpty()) return this;
        var lastPage = pageList.remove(pageList.size()-1);
        var file = lastPage.file();
        if (file.exists()) file.delete();
        return this;
    }
}
